/* Le Peuht un robot rouleur équipé de moteurs pas à pas . Les pas des 
moteurs est réglable par l'enfichage de jumpers.  
Un mode autonomme est possible et l'anti collision est
assurée par un détecteur à ultrasons! Un pilotage manuel peut se faire par
bluetooth et depuis une tablette ou un smart phone ... Le programme vous
laisse la liberté pour toutes modifications ...
B.LECLERC 01/2021
*/


#define TRIGG 10 // Désignation des Entrées/Sorties
#define ECHO 9
#define dirPin 7
#define stepPin 8
#define dirPin1 5
#define stepPin1 6
#define btOk 2
#define stepsPerRevolution 200 // Nb de pas pour un tour de roue
#define Led  13

const long TIMEOUT = 25000UL; // Calcul de la relation temps de l'éco du son <-> distance obstacle
float son = 340.0 / 1000;

char cha; //Déclaration du caractère reçu sur la ligne RS, via le Bluetooth

void moveForward()   {    // Pour faire un Tour de roue en avant  
  digitalWrite(dirPin, HIGH);
    digitalWrite(dirPin1, LOW);
  // Pour 1 tour moteur:
  for (int i = 0; i < stepsPerRevolution; i++) {
    digitalWrite(stepPin, HIGH);
    digitalWrite(stepPin1, HIGH);
    delayMicroseconds(1000);
    digitalWrite(stepPin, LOW);
    digitalWrite(stepPin1, LOW);
    delayMicroseconds(1000);
  }
}

void moveBack()   {     // Pour faire un Tour de roue en arrière
  digitalWrite(dirPin, LOW);
    digitalWrite(dirPin1, HIGH);
  // Pour 1 tour moteur:
  for (int i = 0; i < stepsPerRevolution; i++) {
    digitalWrite(stepPin, HIGH);
    digitalWrite(stepPin1, HIGH);
    delayMicroseconds(1000);
    digitalWrite(stepPin, LOW);
    digitalWrite(stepPin1, LOW);
    delayMicroseconds(1000);
  }
}

 void turnLeft()   {        // Pour tourner à gauche        
  digitalWrite(dirPin, LOW);
    digitalWrite(dirPin1, LOW);
  // Pour 1 tour moteur:
  for (int i = 0; i < stepsPerRevolution; i++) {
    digitalWrite(stepPin, HIGH);
    digitalWrite(stepPin1, HIGH);
    delayMicroseconds(1000);
    digitalWrite(stepPin, LOW);
    digitalWrite(stepPin1, LOW);
    delayMicroseconds(1000);
  }
 }

void turnRight()   {        // Pour tourner à droite 
    digitalWrite(dirPin, HIGH);
    digitalWrite(dirPin1, HIGH);
  // Pour 1 tour moteur:
  for (int i = 0; i < stepsPerRevolution; i++) {
    digitalWrite(stepPin, HIGH);
    digitalWrite(stepPin1, HIGH);
    delayMicroseconds(1000);
    digitalWrite(stepPin, LOW);
    digitalWrite(stepPin1, LOW);
    delayMicroseconds(1000); 
  }
}

void stopRun()   {        // Pour s'arreter encas de besoin
    digitalWrite(dirPin, HIGH);
    digitalWrite(dirPin1, HIGH);
        digitalWrite(stepPin, LOW);
    digitalWrite(stepPin1, LOW);
    delayMicroseconds(1000);  
  }



void setup() {
  //Prédispositions requises avant le dapart des cycles  
  pinMode(stepPin, OUTPUT);
  pinMode(dirPin, OUTPUT);
  pinMode(stepPin1, OUTPUT);
  pinMode(dirPin1, OUTPUT);
  pinMode (TRIGG, OUTPUT);
  digitalWrite (TRIGG, LOW); //Maintient bloquage envoi ultrason
  pinMode (ECHO, INPUT);
  pinMode (btOk, INPUT_PULLUP);
}


void loop() {                   //Départ du cycles défini par le programme
                 moveForward(); //Un pas en avant
                 digitalWrite(TRIGG,HIGH); //Envoi d'un puls d'ultrason de 10ms
                 delayMicroseconds(10);
                 digitalWrite(TRIGG,LOW);

                 int mesure = pulseIn(ECHO,HIGH,TIMEOUT); //Attente de l'écho
                 float distance_mm = mesure /2.0*son;  //Calcul de la distance 

                 if(distance_mm < 200) {         //Si la distance est inférieure à 200mm => Obstacle !
                 delay (1000);
                       moveBack();       // Un pas en arrière
                       int sens = random (10); //pour se dégager et repartir
                     delay(700);
                    if ( sens < 5 ) { 
                    turnLeft();  // Tourne à droite
                     }
                   else {
                      turnRight(); //tourne à gauche
                     } 
                 delay (1000);
                 }

                 if (digitalRead(btOk)) {   // Le récepteur Bluetooth est-il activé ? Si Non ...
                 digitalWrite(Led, HIGH) ; // Led 13 S'allume                 
                 }
                 else {  // Le récepteur Bluetooth est-il activé ? Si Oui
                 digitalWrite(Led, LOW) ; // Led 13 S'eteind
                 delay (50);
                 goto tlCmd; // Saute au sous programme de marche pilotée
                 }

               return; //Si non, retour au début
               

tlCmd:  {         
                 Serial.flush();  //Attente d'un caractère
                 cha = Serial.read();  // Lecture du caractère
                 if (Serial.available()>0) { //Valide si plus grand que nul
                 delay (50);                                             
                    if(cha=='A'){  //Si c'est le caractère A
                         for (int i=0; i <= 10 ; i++)                    
                          digitalWrite(TRIGG,HIGH); //Envoi d'un puls d'ultrason de 10ms
                          delayMicroseconds(10);
                          digitalWrite(TRIGG,LOW);
                          int mesure = pulseIn(ECHO,HIGH,TIMEOUT); //Attente de l'écho
                          float distance_mm = mesure /2.0*son;  //Calcul de la distance 
                              if(distance_mm > 200) {         //Si la distance est supérieure à 200mm => la voie est libre !
                              moveForward();   // 10 pas en avant     
                              delay (50);
                         }

                 }

                 if(cha=='P'){   //Si c'est le caractère P 
                 moveForward();   // un pas en avant
                 }

                 if(cha=='R'){   //Si c'est le caractère R 
                 moveBack();     // etc....
                 }

                 if(cha=='G'){
                 turnLeft();          
                 }

                 if(cha=='D'){
                 turnRight();
                 }

                 if(cha=='S'){
                 stopRun();
                 }
          }
                 
                 delay (50);                
                 goto tlCmd;  //Et on boucle sur l'étiquette tlCmd */
                                 
      }
}
